; #########################################################################
; File:       Dialog7_2.asm
; #########################################################################
      .586                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

; #########################################################################
      include \masm32\include\windows.inc
      include \masm32\macros\macros.asm
      
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\gdi32.inc
      
      include  \MASM32\include\comctl32.inc         ; Para InitCommonControls
;..............................................      
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\gdi32.lib
      
      includelib  \MASM32\lib\comctl32.lib          ; Para InitCommonControls
; #########################################################################

deb MACRO arg		; deb "Test WM_PAINT!"
    pushfd
    pushad
    .if _ShowMSG==IDOK
	mov    _ShowMSG, IDCANCEL	         ; prevent multiple boxes
	invoke MessageBox, hWnd, chr$(<arg>), addr _DebugMsg, MB_OKCANCEL
	mov    _ShowMSG, eax
    .endif
    popad
    popfd
ENDM
; #########################################################################
WinMain     proto :DWORD,:DWORD,:DWORD,:DWORD
WndProc     proto :DWORD,:DWORD,:DWORD,:DWORD
DlgProc     proto :DWORD,:DWORD,:DWORD,:DWORD 
ExitProc    proto  :DWORD,:DWORD,:DWORD,:DWORD       
; #########################################################################
; defined in resource file
;
IDM_Dlg1       equ 1000
IDM_Close      equ 2000

IDC_Nome       equ 12000
IDC_Morada     equ 12001

IDC_TxtNome    equ 11000
IDC_TxtMorada  equ 11001

IDC_Exit       equ 13000
IDC_Cancela    equ 13001
; ##############################################################################################
.data
align 4
_MenuName       db "DIALOG1", 0                 ; definido em rsrc.rc
align 4
_DefDialog1     db "DefDialog1",0               ; definido em rsrc.rc
;...............................................
align 4
_ClassName      db "Class_1", 0
align 4
_DisplayName    db "Dialog 7_2", 0
align 4
_hWnd           dd 0
_hInstance      dd 0
;....................................................
align 4
_Name           db 28 dup (0)
                db 0
align 4
_Address        db 28 dup (0)
                db 0

_hSubDlg        dd 0
_hDlgWnd        dd 0

_hIDC_Exit      dd 0
;......... Strings to Test .............

_ShowMSG	    dd IDOK
_DebugMsg       db 'Test Window', 0
; ##############################################################################################
.code
; -----------------------------------------------------------------------
align 16
start:          invoke GetModuleHandle, NULL 
                mov    _hInstance, eax

                call     InitCommonControls

                invoke   WinMain, _hInstance, NULL, NULL, SW_SHOWDEFAULT
                invoke   ExitProcess, eax       
; #########################################################################
align 16
WinMain proc hInst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
        LOCAL   wc :WNDCLASSEX
        LOCAL   msg:MSG

        mov wc.cbSize,         sizeof WNDCLASSEX
        mov wc.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov wc.lpfnWndProc,    offset WndProc      
        mov wc.cbClsExtra,     NULL
        mov wc.cbWndExtra,     NULL
        push  hInst
	  pop   wc.hInstance

        mov wc.hIcon,     NULL
        
        ;mov wc.hbrBackground,  COLOR_BTNFACE+1             ; system color
        ;mov wc.hbrBackground, COLOR_BACKGROUND + 1
        ;mov wc.hbrBackground, COLOR_WINDOW + 1
        ;mov wc.hbrBackground, COLOR_3DLIGHT + 1
        mov wc.hbrBackground, COLOR_GRADIENTACTIVECAPTION + 1
        
        
        mov wc.lpszMenuName, offset _MenuName      ; menu name in resource file
        mov wc.lpszClassName,  offset _ClassName   ; window class name
        
        invoke LoadCursor, NULL, IDC_ARROW         ; system cursor
        mov wc.hCursor,        eax
        mov wc.hIconSm,        0

        invoke RegisterClassEx, ADDR wc            ; register the window class

        ; ==================================
        ; Create the main application window
        ; ==================================
        invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,
                              ADDR _ClassName,
                              ADDR _DisplayName,
                              WS_OVERLAPPEDWINDOW,
                              140, 100, 500, 350,
                              NULL,NULL,
                              hInst,NULL
        mov     _hWnd, eax  

        invoke ShowWindow, _hWnd, SW_SHOWNORMAL      ; display the window
        invoke UpdateWindow, _hWnd                   ; update the display

          ; ************
          ; Message Loop
          ; ************
@@:       invoke GetMessage, ADDR msg, NULL, 0, 0         ; get each message
          cmp    eax, 0                                   ; exit if GetMessage()
          je     @F                                       
          ;
          invoke TranslateMessage, ADDR msg               ; translate it
          invoke DispatchMessage,  ADDR msg               ; send it to message proc
          jmp    @B
          ;
@@:       mov    eax, 0         
          ret
WinMain   endp
; ##############################################################################################
align 16
WndProc         proc    hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
                mov     eax, uMsg
                mov     edx, wParam                
;                 
                cmp     eax, WM_COMMAND
                jne     _WM_CLOSE
                ;
                ;=============== menu commands =======================
                cmp     edx, IDM_Dlg1
                jne     @F                  
                
                ; --------------------------------------
                ; call DlgProc to process the Dialog Box
                ; --------------------------------------
		    invoke  DialogBoxParam, _hInstance, addr _DefDialog1, hWin, 
                                       offset DlgProc, NULL
                jmp     _eWndProc
                        
@@:             cmp     edx, IDM_Close
                jne     _eWndProc
                ;
                invoke   SendMessage, hWin, WM_SYSCOMMAND, SC_CLOSE, NULL
                jmp     _eWndProc
                ;
                ;============= end menu commands =====================
; 
_WM_CLOSE:      cmp     eax, WM_CLOSE
                je      @F
; 
_WM_DESTROY:    cmp     eax, WM_DESTROY
                jne     _eWndProc
                ;
@@:             invoke  PostQuitMessage, NULL
                mov     eax, 0 
                ret
; 
_eWndProc::     invoke  DefWindowProc, hWin, uMsg, wParam, lParam
                ret
WndProc         endp
; ##############################################################################################
align 16
DlgProc     proc     hWnd:DWORD, iMsg:DWORD, wParam:DWORD, lParam:DWORD

            mov      eax, hWnd
            mov      _hDlgWnd, eax          ; this is the Dialog window's handle ?
                        
	     .if iMsg==WM_INITDIALOG

            ; ------------------------------
            ;  Get the Exit button's handle
            ; ------------------------------
            invoke GetDlgItem, hWnd, IDC_Exit
            mov    _hIDC_Exit, eax
            
            ;###########################################################
            ;**** ExitProc is the NEW processor to the EXIT BUTTON ****
            ; **********************************************************
            ;invoke  SetWindowLong, eax, DWL_DLGPROC, offset ExitProc            
            invoke  SetWindowLong, eax, GWL_WNDPROC, offset ExitProc
            mov     _hSubDlg, eax
            ;###########################################################

            ; --------------------------
            ; Set Focus to edit box Name
            ; --------------------------
		invoke GetDlgItem, hWnd, IDC_Nome
		invoke SetFocus, eax

	     .elseif iMsg==WM_CLOSE

            deb "Close Dialog"

		invoke EndDialog, hWnd, NULL
;####################################################
	     .elseif  iMsg==WM_COMMAND
            mov     eax, wParam
            mov     edx, eax
		shr     edx, 16
        		.if dx==BN_CLICKED
        
                        ; ********************************************************
                        ; Why to test IDC_Exit here IF it is processed by ExitProc
                        ; ********************************************************
	       		.if eax==IDC_Exit

                              deb "EXIT inside DlgProc"

				      invoke GetDlgItemText, hWnd, IDC_Nome, addr _Name, 28+1
				      invoke GetDlgItemText, hWnd, IDC_Morada, addr _Address, 28+1
                              ;
                              invoke    SendMessage, hWnd, WM_CLOSE, NULL, NULL
                              ;                              
        			.elseif eax==IDC_Cancela 
        			;.if eax==IDC_Cancela                       
                              ;
                              deb "CANCEL inside DlgProc"
                              
                              invoke SendMessage, hWnd, WM_CLOSE, NULL, NULL
                              
			     .endif
		      .endif
	      .else
		mov eax, FALSE
		ret
        	.endif
            ;
	      mov  eax,TRUE
	      ret
DlgProc     endp
; ##################################################################################
; SetWindowLong creates the window subclass by changing the window procedure 
; causing the system to call the new window procedure instead of the previous one. 

; An application must pass any messages not processed by the new window procedure 
; to the previous window procedure by calling CallWindowProc. 
;###################################################################################
ExitProc    proc  hWnd:DWORD, iMsg:DWORD, wParam:DWORD, lParam:DWORD

            ;deb "START ExitProc"

	     .if  iMsg==WM_COMMAND

            deb "Command"

            mov     eax, wParam
            mov     edx, eax
		shr     edx, 16
        		.if edx==BN_CLICKED

                        deb "Clicked"

	       		.if eax==IDC_Exit

                              deb "EXIT inside ExitProc"

                              invoke    SendMessage, hWnd, WM_CLOSE, NULL, NULL
                              ;invoke    SendMessage, _hDlgWnd, WM_CLOSE, NULL, NULL                              
                              ;
                              ; processed
                              ; *********
	                        mov  eax, TRUE
	                        ret
                              
			     .endif
		      .endif

            ;.elseif iMsg==WM_PAINT

             ;deb "Msg PAINT"

	      .endif
            ;
            ; not processed
            ; *************
            invoke    CallWindowProc, _hSubDlg, hWnd, iMsg, wParam, lParam
		ret
ExitProc    endp
; #########################################
end start
